/*************************************************************************************/
/*                                                                                   */
/*                        Inet.Mail Web Admin Project                                */
/*                         (c) Nicholas Saxon 1999                                   */
/*                                                                                   */
/*  Author  Nicholas Saxon                                                           */
/*          n.saxon@spinsystems.com                                                  */
/*          (212) 321-2092 ext 108                                                   */
/*          ICQ# 11623870                                                            */
/*                                                                                   */
/*  Version 1.12                                                                     */
/*  Last Change Apr 22, 1999                                                         */
/*************************************************************************************/

out.version	= "v1.12"

parse arg debugopt


Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

/* Register InetMail interface functions					*/

call RxFuncAdd 'HPassLoadFuncs', 'HRxPass', 'HPassLoadFuncs'
call HPassLoadFuncs

call RxFuncAdd 'HMailLoadFuncs', 'HRxMail', 'HMailLoadFuncs'
call HMailLoadFuncs

/*************************************************************************************/
/*  Input preprocessing                                                              */
/*************************************************************************************/

OptionUnnamed = 0				/* All fields are named		*/
OptionMulti   = 1				/* Multiple values allowed	*/
OptionFiles   = 0				/* No files expected		*/
OptionFileMem = 0				/* 				*/

ExitMode      = 1				/* exit from ProduceHTML	*/

if debugopt == '' then OptDebug = 1
		  else OptDebug = debugopt

if OptDebug > 2 then trace ?I

rc = ProcessCGI(OptionUnnamed, OptionMulti, OptionFiles, OptionFileMem, "")

if OptDebug > 1 then trace ?I

/*************************************************************************************/
/*  Ini file processing and first time configuration                                 */
/*************************************************************************************/

out.msg.0	= 0
thispag		= cgi.ThisPage.1.value
submit		= cgi.Submit.1.value
nextpag		= 'email-admin'

PathWA = SysIni(,'InetMail WebAdmin','IniPath')	/* find itself			*/
if PathWA == 'ERROR:' then rc = Die("WebAdmin wasn't installed properly. Can't find homedir.")

if thispag == 'email-admin' then do		/* login and domain name 	*/
	parse var cgi.UserId.1.value uid '@' Domain .
	cgi.UserId.1.value = uid
	/* find the path to InetMail (Pro) domain files				*/
	imr = SysIni(,'InetMail','homedir')	/* find inetmail reg. ini file	*/
	imp = SysIni(,'InetMail','homedirvde')	/* find inetmail vde  ini file	*/
	domains.0 = 0
	if imp <> 'ERROR:' then
		rc = ListDomains(imp'\vdomains.dbf')	/* list known domains	*/
	if imr <> 'ERROR:' then do
		tmp = SysIni(imr'\inetmail.ini','InetMail','hostname')
		if tmp <> 'ERROR:' then do		/* not inplace upgrade	*/
			i = domains.0 + 1
			domains.dname.i = tmp
			domains.dpath.i = imr
			domains.dhome.i = imr'\home'
			domains.0 = i
		   end
		end
	PathIMvd = ''
	if Domain == '' then Domain = domains.dname.1	/* make 1st default one	*/
	do i = 1 to domains.0
		if domains.dname.i == Domain then do
			PathIMvd   = domains.dpath.i
			PathIMhome = domains.dhome.i
			leave
		end
	end
	if PathIMvd == '' then do
		if domains.0 == 0 then rc = Message("WebAdmin was unable to find any Inet.Mail domain")
		else do
			rc = Message("Unknown domain name. Known domains list follows")
			do i = 1 to domains.0
				rc = Message(domains.dname.i)
			end
		     end
		rc = ProduceHTML(PathWA'\email-admin.html',ExitMode,'')
	   end
   end

else do
	PathIMvd   = cgi.PathIMvd.1.value
	PathIMhome = cgi.PathIMhome.1.value
	Domain     = cgi.Domain.1.value
     end

out.xDomain	= Domain
out.xPathIMvd	= PathIMvd
out.xPathIMhome	= PathIMhome

/*************************************************************************************/
/*  Login verification                                                               */
/*************************************************************************************/

rc = VerifyUser(PathIMvd,cgi.UserId.1.value,cgi.Password.1.value)
if rc <> 0 then do
	rc = Message("Login failed." rc)
	rc = ProduceHTML(PathWA'\email-admin.html',ExitMode,'')
end

/*************************************************************************************/
/*  Input processing                                                                 */
/*************************************************************************************/

select

   when thispag == 'email-admin' then do
	nextpag = cgi.NextPage.1.value
   end

   when thispag == 'email-list' then do
	select
		when submit == 'Relogin'then nextpag = 'email-admin'
		when submit == 'Create' then nextpag = 'email-create'
		when submit == 'Delete' then nextpag = 'email-delete'
		when submit == 'Edit'   then nextpag = 'email-edit'
		otherwise nextpag = cgi.NextPage.1.value
	end
   end

   when thispag == 'email-delete' then do
	/* do DELETE action							*/
	if submit == 'Back' then
		nextpag = 'email-list'
	else do
		nextpag = 'email-list'
		user.username = cgi.Deleting.1.value
		rc = HUserInfo(PathIMvd'\inetmail.pas', user.)
		rc = HDeleteUser(PathIMvd'\inetmail.pas', user.username)
		rc = Message(rc)
		if cgi.DelHome.1.value == 'yes' then do
			rc = SysFileTree(user.emaildir'\*','Files','FO')
			if rc <> 0 then
				rc = Message('Not enough memory for home directory deletion')
			else do
				rc = 0
				do i = 1 to Files.0
					rc = rc + SysFileDelete(Files.i)
				end
				drop Files.
				if rc == 0 then
					'@rmdir' user.emaildir
				if rc == 0 then
					rc = Message('Home directory deleted')
				else
					rc = Message("Home directory not deleted completely or didn't exist")
			     end
			end
	     end
   end

   when thispag == 'email-edit' then do
	/* do EDIT action							*/
	do iii = 1 to 1
	nextpag = 'email-list'
	cgi.Select.1.value = cgi.Editing.1.value
	cgi.Select.0 = 1
		if submit == 'Discard' then leave

	nextpag = 'email-edit'
	modflag = 0
	dirflag = 0
	user.username  = cgi.Editing.1.value
	rc = HUserInfo(PathIMvd'\inetmail.pas', user.)
	if Left(rc,2) <> 'OK' then do
		rc = Message("Problem accessing user information:"rc)
		leave
	end

	if user.realname <> cgi.rname.1.value then do
		user.realname  = cgi.rname.1.value
		modflag = 1
	end
	if out.xlogin == 'postmaster' then do
		if user.emaildir <> cgi.hdir.1.value then do
			user.emaildir  = cgi.hdir.1.value
			modflag = 1
			dirflag = 1
		end
	end

	if cgi.chpass.1.value == 'yes' then do
		if cgi.pass1.1.value <> cgi.pass2.1.value then do
			rc = Message('No match between first and second passwords. Reenter')
			leave
			end
		else do
			user.password  = cgi.pass1.1.value
			modflag = 1
		end
	end

	if user.passtype <> cgi.passmode.1.value then do
		user.passtype  = cgi.passmode.1.value
		modflag = 1
	end

	if cgi.forward.1.value == 'yes' then
		tmp = 'true'
	else
		tmp = 'false'
	if cgi.forwto.1.value == '-- non-local user --' then
		cgi.forwto.1.value = cgi.forwnonlocal.1.value
	if user.forward <> tmp | (tmp == 'true' & user.foraddr <> cgi.forwto.1.value) then do
		if tmp == 'true' & cgi.forwto.1.value == '-- no forwarding --' then do
			rc = Message("Choose forwarding destination or uncheck Forward option")
			leave
			end
		else do
			user.forward   = tmp
			user.foraddr   = cgi.forwto.1.value
			modflag = 1
		end
	end

	if cgi.locpr.1.value == 'yes' then
		tmp = 'true'
	else
		tmp = 'false'
	if user.localproc <> tmp | (tmp == 'true' & user.procname <> cgi.locproc.1.value) then do
		if tmp == 'true' & strip(cgi.locproc.1.value) == '' then do
			rc = message("Enter local process name or uncheck Local process option")
			leave
			end
		else do
			user.localproc = tmp
			user.procname  = cgi.locproc.1.value
			modflag = 1
		end
	end

	if cgi.ccmail.1.value == 'yes' then
		tmp = 'true'
	else
		tmp = 'false'
	if user.ccmail <> tmp | (tmp == 'true' & user.ccaddr <> cgi.ccmailto.1.value) then do
		if tmp == 'true' & strip(cgi.ccmailto.1.value) == '' then do
			rc = message("Enter Cc:Mail address or uncheck Cc:Mail option")
			leave
			end
		else do
			user.ccmail = tmp
			user.ccaddr = cgi.ccmailto.1.value
			modflag = 1
		end
	end

	if modflag & submit == 'Save' then do
		if dirflag then
			'@mkdir' user.emaildir
		rc = HCreateUser(PathIMvd'\inetmail.pas', user.)
		if left(rc,2) <> 'OK' then do
			rc = Message("Problem changing user information:"rc)
			leave
		end
	end
	nextpag = 'email-list'
	end /* iii */
   end

   when thispag == 'email-create' then do
	/* do CREATE action							*/
	if submit <> 'Create' then
		nextpag = 'email-list'
	else do iii = 1 to 1
		nextpag = 'email-create'

		/* 1. check account name 					*/
		if cgi.clogin.1.value == '-- account --' then do
			rc = Message("Account name must be assigned")
			leave
		end

		/* 2. check account for duplication				*/
		rc = HQueryUser(PathIMvd'\inetmail.pas', cgi.clogin.1.value)
		if left(rc,2) == 'OK' then do
			rc = Message("Account" cgi.clogin.1.value "already exists")
			leave
			end
		else
			user.username = cgi.clogin.1.value

		/* 3. check real name						*/
		if cgi.rname.1.value == '-- real name --' then do
			rc = Message("Real name must be given")
			leave
			end
		else
			user.realname = cgi.rname.1.value

		/* 4. check password						*/
		if cgi.pass1.1.value <> cgi.pass1.1.value then do
			rc = Message('No match between first and second passwords')
			leave
		end
		if strip(cgi.pass1.1.value) == '' then do
			rc = Message('Password must be assigned')
			leave
			end
		else
			user.password = cgi.pass1.1.value

		/* 5. check homedir						*/
		homed = cgi.hdir.1.value
		if homed == '' then do
			rc = Message('Home directory must be assigned')
			leave
		end
		if homed == PathIMhome then
			homed = homed'\'cgi.clogin.1.value
		user.emaildir = homed
		'@mkdir' homed
		if rc <> 0 then do
			rc = Message("Home directory can't be created")
			leave
		end
		'@rmdir' homed

		/* 6. check forward option					*/
		if cgi.forward.1.value == 'yes' & cgi.forwto.1.value == '-- no forwarding --' then do
			rc = Message("Choose forwarding destination or uncheck Forward option")
			leave
			end
		if cgi.forward.1.value == 'yes' then
			user.forward = 'TRUE'
		else
			user.forward = 'FALSE'
		if cgi.forwto.1.value == '-- no forwarding --' then
			user.foraddr = ''
		else
			user.foraddr = cgi.forwto.1.value

		/* 7. check local process option				*/
		if cgi.locpr.1.value == 'yes' & strip(cgi.locproc.1.value) == '' then do
			rc = message("Enter local process name or uncheck Local process option")
			leave
		end
		if cgi.locpr.1.value == 'yes' then
			user.localproc = 'TRUE'
		else
			user.localproc = 'FALSE'
		user.procname = cgi.locproc.1.value

		/* 8. check ccmail option					*/
		if cgi.ccmail.1.value == 'yes' & strip(cgi.ccmailto.1.value) == '' then do
			rc = message("Enter Cc:Mail address or uncheck Cc:Mail option")
			leave
		end
		if cgi.ccmail.1.value == 'yes' then
			user.ccmail = 'TRUE'
		else
			user.ccmail = 'FALSE'
		user.ccaddr = cgi.ccmailto.1.value

		/* 9. creating the new account					*/
		user.passtype = cgi.passmode.1.value
		rc = HCreateUser(PathIMvd'\inetmail.pas', user.)
		if left(rc,2) <> 'OK' then do
			rc = Message("Problem creating new account:"rc)
			leave
		end
		'@mkdir' homed
		nextpag = cgi.NextPage.1.value
	     end
   end

   otherwise	nextpag = 'email-admin'
end

/*************************************************************************************/
/*  Output data collection                                                           */
/*************************************************************************************/

select
   when nextpag == 'email-delete'   then do
	/* prepare DELETE form							*/
	out.dlogin = ''
	if (cgi.Select.0 == 1) then do
		user.username = cgi.Select.1.value
		rc = HUserInfo(PathIMvd'\inetmail.pas', user.)
		out.dlogin = cgi.Select.1.value
		out.drname = user.realname
	   end
	if out.dlogin == '' then do
		nextpag = 'email-list'
		rc = Message('To delete an account, first choose it with radio button.')
	   end
   end

   when nextpag == 'email-edit'then do
	/* prepare EDIT form							*/
	custom = 'EditIncludes'
	rc = HListUsers(PathIMvd'\inetmail.pas', users.)
	do i = 1 to users.0
		out.uids.i = users.i
	end
	out.uids.0 = users.0
	out.eselect= cgi.Select.1.value
	out.elogin = ''
	if (cgi.Select.0 == 1) then do
		user.username = cgi.Select.1.value
		rc = HUserInfo(PathIMvd'\inetmail.pas', user.)
		out.elogin = cgi.Select.1.value
		out.ername = user.realname
		out.ehdir  = user.emaildir
		out.epassmodes = ''
		out.eapopmodes = ''
		if user.passtype == 'PASS' then
			out.epassmodes = 'checked'
		else
			out.eapopmodes = 'checked'
		if user.forward == 'true' then
			out.eforws = 'checked'
		else
			out.eforws = ''
		out.eforwad= user.foraddr
		if user.localproc == 'true' then
			out.elocprs = 'checked'
		else
			out.elocprs = ''
		out.elocproc = user.procname
		if user.ccmail == 'true' then
			out.eccmails = 'checked'
		else
			out.eccmails = ''
		out.eccmailto = user.ccaddr
	   end
	if out.elogin == '' then do
		nextpag = 'email-list'
		rc = Message('To edit an account, first choose it with radio button.')
	   end
   end

   when nextpag == 'email-create'then do
	/* prepare CREATE form							*/
	custom = 'EditIncludes'
	rc = HListUsers(PathIMvd'\inetmail.pas', users.)
	do i = 1 to users.0
		out.uids.i = users.i
	end
	out.uids.0 = users.0
	if thispag == 'email-create' then do
		out.elogin = cgi.clogin.1.value
		out.ername = cgi.rname.1.value
		out.ehdir  = cgi.hdir.1.value
		out.epassmodes = ''
		out.eapopmodes = ''
		if cgi.passmode1.value == 'PASS' then
			out.epassmodes = 'checked'
		else
			out.eapopmodes = 'checked'
		if cgi.forward.1.value == 'yes' then
			out.eforws = 'checked'
		else
			out.eforws = ''
		out.eforwad= cgi.forwto.1.value
		if cgi.locpr.1.value == 'yes' then
			out.elocprs = 'checked'
		else
			out.elocprs = ''
		out.elocproc = cgi.locproc.1.value
		if cgi.ccmail.1.value == 'yes' then
			out.eccmails = 'checked'
		else
			out.eccmails = ''
		out.eccmailto = cgi.ccmailto.1.value
		end
	else do
		out.elogin = '-- account --'
		out.ername = '-- real name --'
		out.ehdir  = PathIMhome
		out.epassmodes = 'checked'
		out.eapopmodes = ''
		out.eforws = ''
		out.eforwad= ''
		out.elocprs = ''
		out.elocproc = ''
		out.eccmails = ''
		out.eccmailto = ''
		end
   end

   otherwise custom = ''
end

if nextpag == 'email-list' then do
	/* prepare LIST form							*/
	rc = CollectAccountsData()
	custom = 'ListIncludes'
	if out.xlogin == 'postmaster'
		then nextpag = nextpag || 'a'		/* administrator	*/
		else nextpag = nextpag || 'u'		/* user			*/
end

rc = ProduceHTML(PathWA'\'nextpag'.html',ExitMode,custom)

/*------------------------------------------------------------------------------*/
/* Post Mortem Message								*/
/*------------------------------------------------------------------------------*/
Die:
parse arg mtext

crlf = '0d0a'x
Necrolog =	'?Content-type: text/html'crlf,
		''crlf,
		'<!doctype html public "-//w3c//dtd html 4.0 transitional//en">'crlf,
		'<html>'crlf,
		'<head>'crlf,
		'  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">'crlf,
		'  <title>Web-REXX Diagnostics</title>'crlf,
		'</head>'crlf,
		'<body>'crlf,
		'<H2>An error has occurred excuting WebAdmin</h2>'crlf,
		'<h4>'mtext'</h4>'crlf,
		'</body>'crlf,
		'</html>'crlf

rc = ProduceHTML(Necrolog,ExitMode,'')

/*------------------------------------------------------------------------------*/
/* InetMail Account verification 						*/
/*------------------------------------------------------------------------------*/
VerifyUser:

parse arg pwfile, uid, pwd

ui.username = uid
ui.password = pwd
rc = HCheckUser(pwfile'\inetmail.pas', ui.)
if left(rc,2) <> 'OK' then return rc

out.xLogin    = uid
out.xPassword = pwd
return 0

/*------------------------------------------------------------------------------*/
/* InetMail Accounts Data							*/
/*------------------------------------------------------------------------------*/
CollectAccountsData:

pwfile = PathIMvd'\inetmail.pas'
rc = HListUsers(pwfile, users.)

if left(rc,2) <> 'OK' then do
   trc = Message('Error: HListUsers('pwfile') returned' rc)
   out.users.0 = 0
   end
else do
      out.users.0 = users.0
      out.xSelect = 0
      do isn = 1 to out.users.0
	if out.xlogin == users.isn then out.xSelect = users.isn
	user.username = users.isn
	rc = HUserInfo(pwfile, user.)
	if left(rc,2) <> 'OK' then do
		out.realname.isn = '*** ERROR ***'
		out.loginid.isn  = user.username
		out.password.isn = '.'
		out.homedir.isn  = '.'
		out.passtype.isn = '.'
		out.forward.isn  = '.'
		out.forwaddr.isn = '.'
		out.locproc.isn  = '.'
		out.procname.isn = '.'
		out.ccmail.isn   = '.'
		out.ccaddr.isn   = '.'
		out.inbox.isn    = '.'
		end
	else do
		out.realname.isn = user.realname
		out.loginid.isn  = user.username
		out.password.isn = user.password
		out.homedir.isn  = user.emaildir
		out.passtype.isn = user.passtype
		out.forward.isn  = user.forward
		out.forwaddr.isn = user.foraddr
		if out.forwaddr.isn == '' then out.forwaddr.isn = '-'
		if user.forward <> 'true' then out.forwaddr.isn = '<font color="#999999">'out.forwaddr.isn'</font>'
		out.locproc.isn  = user.localproc
		out.procname.isn = user.procname
		if out.procname.isn == '' then out.procname.isn = '-'
		if user.localproc <> 'true' then out.procname.isn = '<font color="#999999">'out.procname.isn'</font>'
		out.ccmail.isn   = user.ccmail
		out.ccaddr.isn   = user.ccaddr
		if out.ccaddr.isn == '' then out.ccaddr.isn = '-'
		if user.ccmail <> 'true' then out.ccaddr.isn = '<font color="#999999">'out.ccaddr.isn'</font>'
		parse value HNumMail(user.username, user.emaildir) with rc num mes .
		if rc == 'OK.' then
			out.inbox.isn    = num
		else
			out.inbox.isn    = '?'
		if out.inbox.isn == '0' then
			out.inbox.isn    = '-'
	     end
      end
     end
return 0

/*------------------------------------------------------------------------------*/
/* ListIncludes Custom function							*/
/*------------------------------------------------------------------------------*/
ListIncludes:
parse arg type,linenum

if type == "bgcolor" then do	/* customize list entries colors		*/

	if out.forward.linenum == 'true' then return '#DBDBB3'	/* forwarded	*/
	if out.locproc.linenum == 'true' then return '#BFBFBF'	/* process	*/
	return '#D0FFD0'					/* normal	*/
	end

else do				/* customize legend colors			*/

	if linenum == 1 then return '#D0FFD0'			/* normal	*/
	if linenum == 2 then return '#DBDBB3'			/* forwarded	*/
	return '#BFBFBF'					/* process	*/
end

/*------------------------------------------------------------------------------*/
/* EditIncludes Custom function							*/
/*------------------------------------------------------------------------------*/
EditIncludes: procedure expose out.
parse arg type

if type == 'editmode' then do
	if out.xlogin == 'postmaster' then
		return '<input type="text" size="50" name="hdir"  value="'out.ehdir'">'
	else
		return out.ehdir
end

if out.eforws == '' & strip(out.eforwad) == '' then do
	inc = '<option value="-- no forwarding --" selected>-- no forwarding --'
	found = 1
	end
else
	inc = '<option value="-- no forwarding --"         >-- no forwarding --'

do i = 1 to out.uids.0
	if out.uids.i == out.eforwad then do
		add = '<option value="'out.uids.i'" selected>'out.uids.i
		found = 1
		end
	else
		add = '<option value="'out.uids.i'"         >'out.uids.i
	inc = inc add
end

if found <> 1 then do
	add = '<option value="-- non-local user --" selected>-- non-local user --'
	out.eforwnonloc = out.eforwad
	end
else do
	add = '<option value="-- non-local user --"         >-- non-local user --'
	out.eforwnonloc = ''
	end
inc = inc add
return inc

/*------------------------------------------------------------------------------*/
/* weekday custom function							*/
/*------------------------------------------------------------------------------*/
weekday:
return left(date('w'),3)

/*------------------------------------------------------------------------------*/
/* Message									*/
/*------------------------------------------------------------------------------*/
Message: procedure expose out.
parse arg text

i = out.msg.0 + 1
out.msg.i = text
out.msg.0 = i
return ''

/*------------------------------------------------------------------------------*/
/* Looking into domains definition data base					*/
/*------------------------------------------------------------------------------*/
ListDomains: procedure expose domains.

domains. = 0

parse arg vdfile

cr = '0D'x
size = stream(vdfile,'Command','query size')
if size == '' then do /* no dbf, trying text file				*/

	vdfile = left(vdfile,length(vdfile)-4)
	size = stream(vdfile,'Command','query size')
	if size == '' then return 1 	/* no help				*/

	s = stream(vdfile,'Command','Open Read')
	if s <> 'READY:' then exit 10
	txt = charin(vdfile,,size)
	s = stream(vdfile,'Command','Close');
	drop size

	i = 0
	do while txt <> ''
		i = i + 1
		parse var txt vd '0d0a'x txt
		parse var vd vdname "|" . "|" vdpath "|" vdhome "|" .
		domains.dname.i = strip(vdname)
		domains.dpath.i = strip(vdpath)
		domains.dhome.i = strip(vdhome)
	end
	domains.0 = i
	rc = VerifyDomains()
	return 0

end

s = stream(vdfile,'Command','Open Read')
if s <> 'READY:' then exit 10
dbf = charin(vdfile,,size)
s = stream(vdfile,'Command','Close');
drop size

/* parsing DB headers								*/

hdr = left(dbf,32)

parse var hdr 1 . 5 nrec 9 hdrlen 11 reclen 13 .
nrec   = c2d(reverse(nrec))
hdrlen = c2d(reverse(hdrlen))
reclen = c2d(reverse(reclen))

fdata = substr(dbf,hdrlen+1)
dbf  = left(dbf,hdrlen)
dbf  = substr(dbf,33)

i = 0
do while dbf <> ''

	i = i + 1
	parse var dbf 1 hdr 33 dbf
	if left(hdr,1) == cr then leave

	parse var hdr 1 field.name.i 12 field.type.i 13 . 17 field.size.i 18 .
	field.name.i = strip(field.name.i,,'0'x)
	if pos('0'x,field.name.i) > 0 then
		field.name.i = left(field.name.i,pos('0'x,field.name.i)-1)
	field.size.i = c2d(field.size.i)

end

field.0 = i - 1

/* parsing DB records								*/

count = 0

do i = 1 to nrec

	line  = substr(fdata,1,reclen)
	fdata = substr(fdata,reclen+1)

	parse var line 1 flag 2 data

	do j = 1 to field.0
		fd = substr(data,1,field.size.j)
		data = substr(data,field.size.j+1)
		nam = field.name.j
		select
			when nam == 'DOMAIN' then domains.dname.i = strip(fd)
			when nam == 'PATH'   then domains.dpath.i = strip(fd)
			when nam == 'HOME'   then domains.dhome.i = strip(fd)
			otherwise nop
		end
	end
	count = count + 1

end

domains.0 = count
rc = VerifyDomains()
return 0

/*------------------------------------------------------------------------------*/
/* Looking into domains for a valid password file				*/
/*------------------------------------------------------------------------------*/
VerifyDomains: procedure expose domains.

do i = 1 to domains.0
	rc = stream(domains.dpath.i'\inetmail.pas','command','query size')
	if rc == '' then domains.dname.i = '?'domains.dname.i
end

return 0

/*************************************************************************************/
/*                                                                                   */
/*                              WEB-REXX PROJECT                                     */
/*                          (c) Nicholas Saxon 1999                                  */
/*                                                                                   */
/*  Author  Nicholas Saxon                                                           */
/*          n.saxon@spinsystems.com                                                  */
/*          (212) 321-2092 ext 108                                                   */
/*          ICQ# 11623870                                                            */
/*                                                                                   */
/*  Version 1.2                                                                      */
/*  Last Change Apr 20, 1999                                                         */
/*************************************************************************************/

/*************************************************************************************/
/*                                                                                   */
/*                                ProcessCGI                                         */
/*                                                                                   */
/*  Function                                                                         */
/*                                                                                   */
/*          This REXX script is designed to be a general helper for CGI developers   */
/*          for REXX.                                                                */
/*                                                                                   */
/*          It carries out all interfacing with Web Server by interrogating          */
/*          the execution environment, parsing input, including forms, if any,       */
/*          and returns a REXX stem filled out with processed variables.             */
/*                                                                                   */
/*          You then analyse stem variables, do functional part and call another     */
/*          REXX script, ProduceHTML for generation of the HTML output.              */
/*                                                                                   */
/*          REXXUTIL package must be preloaded.                                      */
/*                                                                                   */
/*  Limitations                                                                      */
/*                                                                                   */
/*          Tested with Lotus Go Webserver only.                                     */
/*          Only GET and POST methods are recognized (is anything else out there?)   */
/*                                                                                   */
/*          The following encoding types are recognized in forms:                    */
/*                                                                                   */
/*          - application/x-www-form-urlencoded                                      */
/*                                                                                   */
/*              This is the default one used in forms. Use it only in simple forms.  */
/*                                                                                   */
/*          - multipart/form-data                                                    */
/*                                                                                   */
/*              This is the most general encoding type, allowing file uploading etc. */
/*              Recommended.                                                         */
/*                                                                                   */
/*          Form field names must be valid REXX variable names.                      */
/*                                                                                   */
/*                                                                                   */
/*  Arguments                                                                        */
/*                                                                                   */
/*    OptionUnnamed   Controls acceptance of unnamed fields                          */
/*                                                                                   */
/*                0   reject and terminate                                           */
/*                1   accept                                                         */
/*                2   ignore and continue                                            */
/*                                                                                   */
/*    OptionMulti     Controls acceptance of duplicated fields                       */
/*                                                                                   */
/*                0   reject and terminate                                           */
/*                1   accept                                                         */
/*                2   ignore and continue                                            */
/*                                                                                   */
/*    OptionFiles     Controls acceptance of file uploads                            */
/*                                                                                   */
/*                0   reject and terminate                                           */
/*                1   accept                                                         */
/*                2   ignore and continue                                            */
/*                                                                                   */
/*    OptionFileMem   Controls resident files                                        */
/*                                                                                   */
/*                0   save file under temporary name in fdir, field value is empty   */
/*                1   save file as for 0 AND keep up to 1024 first bytes in value    */
/*                2   save file as for 0 AND keep ALL data in value                  */
/*                3   don't save file to disk but keep ALL data in value             */
/*                                                                                   */
/*    fdir  directory to place uploaded files, if any                                */
/*                                                                                   */
/*                                                                                   */
/*  Return code                                                                      */
/*                                                                                   */
/*      0   OK                                                                       */
/*      1   Unrecognized request method                                              */
/*      2   No data to process                                                       */
/*      3   Unrecognized content type                                                */
/*      4   Unnamed fields not allowed but encountered                               */
/*      5   Duplicated fields not allowed but encountered                            */
/*      6   Invalid field name                                                       */
/*      7   MIME format violation. No closing boundary                               */
/*      8   'MIME format violation. Misformed data                                   */
/*      9   fdir not specified but needed                                            */
/*     10   Problem creating temporary file for uploading                            */
/*     11   Problem saving uploaded file                                             */
/*     12   Problem closing saved file                                               */
/*     16   Option out of range                                                      */
/*                                                                                   */
/*  Output                                                                           */
/*                                                                                   */
/*      cgi.msg                 Nothing / Warning / Error message                    */
/*      cgi.method              For reference: form method used GET / POST or unkn.  */
/*      cgi.contenttype         For reference: Content-type used                     */
/*      cgi.contentlength       For reference: Content length                        */
/*      cgi.query               For reference: up to 1024 bytes of query string      */
/*      cgi.fields.0            Count of input fields                                */
/*      cgi.fields.1..N         Names of input fields                                */
/*                                                                                   */
/*  and                        (OptionMulti = 1)                                     */
/*                                                                                   */
/*      cgi.NAME.0              Count of fields named NAME                           */
/*      cgi.NAME.1..N.value     Values of fields named NAME                          */
/*      cgi.NAME.1..N.type      Types of fields named NAME var/file                  */
/*      cgi.NAME.1..N.temp      Temporary file names for file fields named NAME      */
/*      cgi.NAME.1..N.file      Original file names for file fields named NAME       */
/*                                                                                   */
/*  or                         (OptionMulti <> 1)                                    */
/*                                                                                   */
/*      cgi.NAME.0              Always 1                                             */
/*      cgi.NAME.value          Value of field named NAME                            */
/*      cgi.NAME.type           Type  of field named NAME var/file                   */
/*      cgi.NAME.temp           Temporary file name for file field named NAME        */
/*      cgi.NAME.file           Original  file name for file field named NAME        */
/*                                                                                   */
/*************************************************************************************/

ProcessCGI: procedure expose cgi. OptDebug

parse arg OptionUnnamed, OptionMulti, OptionFiles, OptionFileMem, fdir

cgi. = 0
cgi.msg = ''

/* Interrogating environment							*/

if OptDebug < 2 then do
	rm = getenv('REQUEST_METHOD')
	cgi.method = rm

	select
	  when rm == 'GET'  then do
					input = getenv('QUERY_STRING')
					cl = length(input)
					ct = 'application/x-www-form-urlencoded'
				 end
	  when rm == 'POST' then do
					cl = getenv('CONTENT_LENGTH')
					ct = getenv('CONTENT_TYPE')
					input = charin(,,cl)
				 end
	  otherwise do
			cgi.msg = 'Unrecognized request method'
			return 1
		    end
	end /* select */
	if OptDebug == 1 then do
				ql = length(ct)
				trc = SysFileDelete('query')
				trc = charout('query',rm':'ql':'ct||input)
				trc = stream('query','command','close')
			      end
	end /* then */
else	do
		trc = stream('query','command','query size')
		trc = charin('query',,trc)
		parse var trc rm ':' ql ':' trc
		ct = substr(trc,1,ql)
		input = substr(trc,ql+1)
		trc = stream('query','command','close')
	end

cgi.contenttype   = ct
cgi.contentlength = cl

if cl == 0 then do
   cgi.msg = 'No data to process'
   return 2
end

if cl > 1024 	then ck = 1024
		else ck = cl
cgi.query = left(input,ck)

/* Recognize content type							*/

select
  when ct = "application/x-www-form-urlencoded"	then cti = 1
  when  abbrev(ct,"multipart/form-data")	then cti = 2
  otherwise do
		cgi.msg = 'Unrecognized content type'
		return 2
	    end
end

/* Parse application/x-www-form-urlencoded form input				*/

if cti == 1 then do

   do while input <> ""
	parse var input field '&' input	/* separate fields			*/
	parse var field fname '=' fdata	/* separate name and data		*/
	if pos('=',field) == 0 then do
					fdata = fname
					fname = ''	/* anonymous field	*/
				    end
	/* decoding url encoded data						*/
	data = translate(fdata,' ','+')
	fdata = ""
	do while pos('%',data) > 0
		parse var data databeg '%' data
		parse var data 1 xx 3 data
		fdata = fdata || databeg || x2c(xx)
	end
	fdata = fdata || data
	/* put it into cgi. stem						*/
	rc = StoreField('var',fname,fdata,'n/a','n/a')
	if rc <> 0 then return rc
   end

   return 0

end

/* Parse multipart/form-data form input						*/

crlf = '0d0a'x

parse var ct "multipart/form-data; boundary=" boundary
bl = length(boundary)

start = pos('--'boundary||crlf,input)
if start <> 1 then do
   parse var input tmp ('--'boundary||crlf) input
   cgi.msg = 'Warning: MIME format violation. Unexpected data skipped preceding starting boundary'
end
else
   input = substr(input,bl+4)

do forever /* looking through parts						*/

   bd = crlf||'--'boundary
   stop  = pos(bd,input)
   if stop = 0 then do
	cgi.msg = 'MIME format violation. No closing boundary'
	return 7
	end
   else
	parse var input data (bd) input

   /* A part extracted. Parsing headers						*/

   FileName = ''

   do forever	/* looking through part						*/

      parse var data header (crlf) data

      if header <> '' then do	/* still in headers				*/

	 if pos('Content-Disposition:',header) > 0 then do

		/* extract part name						*/
		parse var header 'name="' FieldName '"' .

		if pos('filename=',header) > 0 then do
			FieldType = 'file'
			parse var header . 'filename="' FileName '"' .;
			end
		else
			FieldType = 'var'
	 end

      end

      else do	/* end of headers						*/
		/* extract part data						*/
		select
		   when FieldType == 'var'  then do
							rc = StoreField('var',FieldName,data,'n/a','n/a')
							if rc <> 0 then return rc
						 end
		   when FieldType == 'file' then do
							rc = ProcessFile(FieldName,data,FileName)
							if rc <> 0 then return rc
						 end
		end
		leave	/* finish with this part				*/
	   end
   end		/* looking through part						*/

   /* Looking for another part if any						*/

   if input == '--'crlf then
      leave

   if left(input,2) == crlf then
      input = substr(input,3)
   else do
      cgi.msg = 'MIME format violation. Misformed data'
      return 8
   end

end

return 0

/*********************************************************************/
getenv: procedure
return value(arg(1),, 'os2environment')

/*********************************************************************/
ProcessFile:

  parse arg fieldname, fd, orgfile

  select

	when OptionFileMem == 0 then do	/* save only			*/
					rc = SaveFile(fd)
					fd = ''
					if rc <> 0 then return rc
				     end
	when OptionFileMem == 1 then do /* save and keep 1024 resident	*/
					rc = SaveFile(fd)
					if length(fd) > 1024 then fd = left(fd,1024)
					if rc <> 0 then return rc
				     end
	when OptionFileMem == 2 then do /* save and keep all resident	*/
					rc = SaveFile(fd)
					if rc <> 0 then return rc
				     end
	when OptionFileMem == 3 then do /* don't save and keep resident	*/
					tempname = ''
				     end
	otherwise do
			cgi.msg = 'OptionFileMem out of range'
			return 16
		  end
  end

  rc = StoreField('file',fieldname,fd,tempname,orgfile)

return rc

/*********************************************************************/
SaveFile:

  if fdir == "" then do
			cgi.msg = 'Directory for uploaded file needed'
			return 9
		   end
  tempname = SysTempFileName(fdir'\cgiupload.?????')
  if tempname == '' then do
			cgi.msg = 'Problem creating temporary file for uploading'
			return 10
		       end
  rc = charout(tempname,fd)
  rl = stream(tempname,'command','close')
  if rc <> 0 then do
			cgi.msg = 'Problem saving uploaded file'
			return 11
		  end
  if left(rl,5) <> 'READY' then do
					cgi.msg = rl
					return 12
				end
return 0

/*********************************************************************/
StoreField:

  parse arg ft, fn, fd, tmpfile, origfile

  if fn <> "" then
     if symbol(fn) == 'BAD' then do
					cgi.msg = 'Invalid field name'
					return 6
				 end
     else nop
  else do
     select
	when OptionUnnamed == 0 then do
					cgi.msg = 'Unnamed fields not allowed'
					return 4
				     end
	when OptionUnnamed == 1 then fn = 'unnamed'
	when OptionUnnamed == 2 then return 0
	otherwise do
			cgi.msg = 'OptionUnnamed out of range'
			return 16
		  end
     end
  end

  dcount = value('cgi.'fn'.0')

  if dcount > 0 then do
     select
	when OptionMulti == 0 then do
					cgi.msg = 'Duplicated fields not allowed'
					return 5
				   end
	when OptionMulti == 1 then nop;
	when OptionMulti == 2 then return 0
	otherwise do
			cgi.msg = 'OptionMulti out of range'
			return 16
		  end
     end
  end

  dcount = dcount + 1
  if OptionMulti == 1 then do
	rc = value('cgi.'fn'.0',dcount)
	rc = value('cgi.'fn'.'dcount'.value',fd)
	rc = value('cgi.'fn'.'dcount'.type',ft)
	rc = value('cgi.'fn'.'dcount'.temp',tmpfile)
	rc = value('cgi.'fn'.'dcount'.file',origfile)
	end
  else do
	rc = value('cgi.'fn'.0',dcount)
	rc = value('cgi.'fn'.value',fd)
	rc = value('cgi.'fn'.type',ft)
	rc = value('cgi.'fn'.temp',tmpfile)
	rc = value('cgi.'fn'.file',origfile)
       end

  count = cgi.fields.0 + 1
  cgi.fields.0 = count
  if OptionMulti == 1 then
     cgi.fields.count = fn'.'dcount
  else
     cgi.fields.count = fn

return 0

/*************************************************************************************/
/*                                                                                   */
/*                                ProduceHTML                                        */
/*                                                                                   */
/*  Function                                                                         */
/*                                                                                   */
/*          This REXX script is designed to be a general helper for CGI developers   */
/*          for REXX.                                                                */
/*                                                                                   */
/*          It performs HTML output based on templates with a number of ways of      */
/*          dynamic variable substitutions. Looping is supported for generating      */
/*          table rows.                                                              */
/*                                                                                   */
/*  Dynamics                                                                         */
/*                                                                                   */
/*          As a general rule: the dynamically generated output is not rescanned for */
/*          further interpretation. This assures that process eventually ends.       */
/*          Spaces within dynamics constructs between '$' and '(' charactes are not  */
/*          allowed. Violation of this rule makes the offendive construct            */
/*          unrecognisable. Between parenthesis spaces are allowed.                  */
/*                                                                                   */
/*          REXX Variables substitution:                                             */
/*                                                                                   */
/*               A construct like  $(name) is going to be substituted with the REXX  */
/*               variable 'name' if there is one defined. Compound names with dots   */
/*               f.i. $(cgi.method) are allowed.                                     */
/*                                                                                   */
/*               Due to REXX rules of variables scope only variables belonging to    */
/*               the stem out. will be recognized and produce expected results, f.i. */
/*               $(out.weekday) is OK, but $(weekday) is invisible and will produce  */
/*               WEEKDAY as the output.                                              */
/*                                                                                   */
/*               By the moment I've got no better idea. One can delete 'procedure'   */
/*               statement and make all variables visible (and sensitive).           */
/*                                                                                   */
/*          Builtin Functions                                                        */
/*                                                                                   */
/*               A construct like $name(parameters) refers to a REXX builtin function*/
/*               and is going to be substituted with its result.                     */
/*                                                                                   */
/*               Note! To simplify implementation, parameters are assumed neither to */
/*               contain closing parenthesis nor to be scanned. The following example*/
/*               WILL NOT not produce intended results: $date(left(mode,1))          */
/*               This behaviour may change in the future.                            */
/*                                                                                   */
/*               No check is made wether the function referenced actually exists and */
/*               is the REXX builtin function. So, you may try to call your own REXX */
/*               functions, at your own risk entirely. Frankly, you risk the line to */
/*               be dropped from output if you misspelled function name.             */
/*                                                                                   */
/*          Loops                                                                    */
/*                                                                                   */
/*               A construct like                                                    */
/*                                                                                   */
/*                 $loop(Number-or-REXX-var-name)                                    */
/*                   ..line..                                                        */
/*                   ..line..                                                        */
/*                 $endloop()                                                        */
/*                                                                                   */
/*               marks group of lines to be output multiple times. Within this       */
/*               context usual substitutions work as described. REXX-var-name refers */
/*               to a variable containing the number of repetitions. Constant is     */
/*               allowed as well.                                                    */
/*                                                                                   */
/*               Everything following the loop/endloop construct is ignored to the   */
/*               end of the line.                                                    */
/*                                                                                   */
/*               Special form of name like $(name.*) refers to the indexed values    */
/*               name.1, name.2 etc where index is the looping counter.              */
/*                                                                                   */
/*               The variable $(Looping) produces the current loop's pass number.    */
/*                                                                                   */
/*          Custom inclusions                                                        */
/*                                                                                   */
/*               When above stuff seems to be not enough, one can do customization   */
/*               with user-supplied function calls.                                  */
/*                                                                                   */
/*               A construct like $include(parameters) will call a user provided     */
/*               function with the parameters specified. Parameters can help         */
/*               identify the inclusion point etc.                                   */
/*                                                                                   */
/*  Limitations                                                                      */
/*                                                                                   */
/*          Nested loops are not supported. Multiple loops within the same HTML page */
/*          are welcome.                                                             */
/*                                                                                   */
/*                                                                                   */
/*  Arguments                                                                        */
/*                                                                                   */
/*    template    file name of HTML template  OR, for in-memory templates:           */
/*                a string of '?' immediately followed by the template text          */
/*                                                                                   */
/*                                                                                   */
/*    exitmode    controls return/exit                                               */
/*                                                                                   */
/*      0         return to caller with RC                                           */
/*      1         exit; in case of problems generate diagnostic HTML page            */
/*                                                                                   */
/*    custom      function name to call for custom inclusions                        */
/*                                                                                   */
/*  Return code                                                                      */
/*                                                                                   */
/*      0   OK                                                                       */
/*      1   Template not found. No output produced                                   */
/*                                                                                   */
/*************************************************************************************/

ProduceHTML: procedure expose out.

parse arg templatefile, exitmode, custom .

/* Diagnostic HTML page								*/

crlf = '0d0a'x
diagnostics =	'Content-type: text/html'crlf,
		''crlf,
		'<!doctype html public "-//w3c//dtd html 4.0 transitional//en">'crlf,
		'<html>'crlf,
		'<head>'crlf,
		'  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">'crlf,
		'  <title>Web-REXX Diagnostics</title>'crlf,
		'</head>'crlf,
		'<body>'crlf,
		'<H2>Internal error occurred preventing HTML page to be generated</h2>'crlf,
		'Document requested:'  templatefile'; current path is' directory() crlf,
		'</body>'crlf,
		'</html>'crlf

/* Read the template in memory							*/

rc = 1

if left(templatefile,1) == '?' then		/* memory resident template	*/
	template = substr(templatefile,2)
else do
	size = stream(templatefile,'command','query size')
	if size == '' then do
	   if exitmode == 0 then return 1
	   else template = diagnostics
	   end
	else do
		rc = stream(templatefile,'command','open read')
		if left(rc,5) <> 'READY' then do
		   if exitmode == 0 then return 1
		   else template = diagnostics
		   end
		else do
			template = charin(templatefile,,size)
			rc = stream(templatefile,'command','close')
		     end
	     end
end

/* Interpret the template and produce output					*/

rc = 0

if left(template,13) <> 'Content-type:' then do
   say 'Content-type: text/html'
   say ''
end

Looping = 0
Dumb = 0
DoTemplate:

do while template <> ""

   parse var template line (crlf) template
   line = strip(line,'Trailing')

   out = ''
   do while line <> ''

      ps = pos('$',line)
      pl = pos('(',line)
      pr = pos(')',line)

      parse var line  linebeg '$' FuncStmt '(' VarParam ')' rest
      out = out || linebeg

      pb = pos(' ',FuncStmt)

      if (ps > 0 & pl > 0 & pr > 0 & ps < pl & pl < pr | pb > 0) then nop
      else do
		if ps > 0 then out = out || '$';
		parse var line . '$' line
		iterate
	   end

      /* found something to interpret						*/

      select

	when FuncStmt == ''        then do	/* Variable substitution	*/
						if VarParam <> '' then do
						   if right(VarParam,2) == '.*' then do
							if Looping > 0 then
							   out = out || value(left(VarParam,length(VarParam)-1)||Looping)
							else
							   out = out || '$('VarParam')'
							end
						   else
							out = out || value(VarParam)
						end
					end
	when FuncStmt == 'loop'    then do	/* Loop starts			*/
						if Looping > 0 then
							out = out || '$loop('VarParam')'
						else do
							LoopFor = value(VarParam)
							if datatype(LoopFor,'whole') then do
								Looping = 1;
								LoopAt  = template
								if LoopFor < 1 then Dumb = 1
								end
							else
								out = out || '$loop('VarParam')'
						     end
					end
	when FuncStmt == 'loopend' then do	/* Loop ends			*/
						Dumb = 0
						if Looping > 0  then do
									Looping = Looping + 1
									if Looping <= LoopFor then
										template = LoopAt
									else
										Looping = 0
								     end
						else
							out = out || '$loopend('VarParam')'
					end
	when FuncStmt == 'include' then do	/* Custom inclusion		*/
						signal on syntax
						interpret 'out=out||'custom'('VarParam');'
						signal off syntax
					end
	otherwise do				/* looks like function call	*/
			signal on syntax
			interpret 'out=out||'FuncStmt'('VarParam');'
			signal off syntax
		  end
      end
      line = rest

   end

   if Dumb == 0 then say out

end

if exitmode == 0 then return rc
		 else exit rc

syntax:
line = rest
signal DoTemplate
