/*************************************************************************************/
/*                                                                                   */
/*                        Inet.Mail Web Admin Project                                */
/*                         (c) Nicholas Saxon 1999                                   */
/*                                                                                   */
/*  Author  Nicholas Saxon                                                           */
/*          n.saxon@spinsystems.com                                                  */
/*          (212) 321-2092 ext 108                                                   */
/*          ICQ# 11623870                                                            */
/*                                                                                   */
/*  Version 1.1                                                                      */
/*  Last Change Mar 25, 1999                                                         */
/*************************************************************************************/

/*************************************************************************************/
/*                       Zero Level Installation Script                              */
/*<--                                                                                */
/*            Welcome to the Inet.Mail(tm)^ WebAdmin v1.12 Installation!             */
/*            ==========================================================             */
/*                                                                                   */
/* WebAdmin is a prototype of what is gonna be a Web Control Center eventually.      */
/* Copyright (c) Nicholas Saxon 1999                                                 */
/*                                                                                   */
/* You are granted the right to use it freely, including modifications of the        */
/* REXX sources. However, the original copyright notice should be kept.              */
/*                                                                                   */
/* I would like to say it's published under GPL, if I had read it :-(                */
/*                                                                                   */
/*          NO WARRANTY OF ANY KIND. USE IT AT YOUR OWN RISK                         */
/*                                                                                   */
/* This script should be run on a system where the Inet.Mail or Inet.Mail Pro        */
/* server (or even both) are installed, from its target directory.                   */
/*                                                                                   */
/* It does three things WebAdmin needs to run:                                       */
/*                                                                                   */
/* - copies email-entry.html to your HTML directory;                                 */
/* - copies email-admin.cmd  to your CGI-BIN directory;                              */
/* - registers its location in OS2.INI file ('InetMail WebAdmin','IniPath')          */
/*----------------                                                                   */
/* ^ Inet.Mail is a trademark of Hethmon Brothers.                                   */
/*-->                                                                                */
/*************************************************************************************/

signal on halt

call Greetings
say 'Press ENTER to continue, Ctrl+C to abort'
pull

/* checking prerequisites					*/

Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

imr = SysIni(,'InetMail','homedir')
imp = SysIni(,'InetMail','homedirvde')

if imr == 'ERROR:' & imp == 'ERROR:' then do
	say "First install Inet.Mail or Inet.Mail Pro!"
	exit 1
end

rc = RxFuncAdd('HPassLoadFuncs', 'HRxPass', 'HPassLoadFuncs')
if rc <> 1 then do
	say "The complimentary library HRxPass didn't load."
	say "Install both HRxPass and HRxMail libraries before trying to instal WebAdmin"
	say "You can download them from Hethmon Brothers' FTP site ftp.hethmon.com"
	exit 2
end

rc = RxFuncAdd('HMailLoadFuncs', 'HRxMail', 'HMailLoadFuncs')
if rc <> 1 then do
	say "The complimentary library HRxMail didn't load."
	say "Install both HRxPass and HRxMail libraries before trying to instal WebAdmin"
	say "You can download them from Hethmon Brothers' FTP site ftp.hethmon.com"
	exit 2
end

d = directory()
say 'Installing from' d

/* Copying html							*/
say "Specify your Web Server's HTML location for WebAdmin entry page:"
say "(you can use any existing directory you can reach with browser)"
pull docdir
address 'cmd' '@copy email-entry.html' docdir'\email-entry.html'
if rc <> 0 then call Fail docdir'\email-entry.html'

/* Copying cgi							*/
say "Specify your Web Server's CGI-BIN location for WebAdmin CGI script:"
say "(refer to your web server configuration files)"
pull cgidir
address 'cmd' '@copy email-admin.cmd' cgidir'\email-admin.cmd'
if rc <> 0 then call Fail docdir'\email-admin.cmd'

/* Writing INI							*/

rc = SysIni(,'InetMail WebAdmin','IniPath',d)
if rc <> '' then call Fail 'OS2.INI'

/* Exit								*/
say ""
say ""
say "WebAdmin is successfully installed."
say "Point you browser to email-entry.html and log in!"
say ""
say "Note 1. Edit HTML files for right locations of logo and background images."
say "Note 2. Log in as postmaster@domain to have full control over all accounts."
say "        Log in as an e-mail user to do self-service."
say "Note 3. @domain is optional for non-Inet.Mail Pro installations."
exit 0

halt:
say 'Cancelled'
exit 111

/* Greetings							*/
Greetings:
dumb = 1
do i = 1 to sourceline()
	line = sourceline(i)
	if left(line,5) == '/*<--' then do
		dumb = 0
		iterate
	end
	if left(line,5) == '/*-->' then leave
	if \dumb then do
		parse var line '/*' text '*/'
		say strip(text,'trail')
	end
end
return

/* Fail								*/
Fail:
parse arg file

say "Error when writing to" file
say "Installation failed."
exit 99
